'
'                           Ŀ
'                             2SET_COM.BAS  
'                           
'
'                        Wed  08-17-1994  18:18:06
'
'    A true-blue QuickBASIC 4.5 program that:
'
'    1.   Sniffs out the COM ports I/O Address in low BIOS Memory.
'
'    2.   Ask you if you want to fill the empty Addresses with the
'         standard Address for that COM port.
'
'    3.   Displays the COM port I/O Addresses again, and if all four
'         are present.... waves goodbye.
'
'    Don't ask. Yep, I'm back in QuickBASIC though I can "do" Visual
'    BASIC for Windows. Easier to debug tricky and =dangerous= stuff
'    like setting and destroying COM port addresses in DOS.
'
'    Had to came back here as I am having modem trouble in the office.
'    Find very little help on testing modems and COM ports from modem
'    manufacturers. One program from ProComm Plus (Datastorm,
'    International, Inc) locked my computer tighter than a tick.
'
'    Ŀ
'    IF YOU WANT TO MODIFY THIS CODE
'    
'    This QuickBASIC 4.5 program was changed "slightly" so that it could
'    be compiled using Crescent Softwares's PDQ.LIB. If you try to RUN
'    it in the QuickBASIC Environment, you will have to modify the code
'    to be pure QuickBASIC again.
'
'    I used to upload a separate QuickBASIC program to CompuServe's
'    MSBASIC Forum, but "Tempus Fugits" and I am out of "Tempus." So...
'    "step" the program, read the errors and change the code. I have
'    left notes along the way to guide you.
'
'    John De Palma on CompuServe 76076,571
'
'    
'                               REFERENCES
'
'    1. Norton PC Programmer's Bible 1993 Version, page 531
'
'    2. Microsoft Knowledge Base Document #: Q76742, Oct 4, 1991
'
'    3. Windows Resource Kit Version 3.1, page 347
'
'     END OF TEXT 
'
'
'This is for PDQ, contains all SUBs and FUNCTIONS in one module

'Declarations
DEFINT A-Z
DECLARE SUB LocateIt (Row%, text$)
DECLARE SUB ColorIt (Fgd%, Bkg%)
DECLARE SUB CursorOff ()
DECLARE SUB CursorOn ()
DECLARE SUB TextBoxShadow (Row%, Col%, Message$, Outline%, Shadow%, Length%)
DECLARE SUB WaitKey ()
DECLARE SUB WidenMsg (MsgLength%, Message$)
DECLARE SUB PokeWord (Address%, Value%)
DECLARE SUB TwoColrs (Fgd%, Bkg%, Colr%)

'Functions
DECLARE FUNCTION Center% (text$)
DECLARE FUNCTION YesNo% (Answer$)
DECLARE FUNCTION PeekWord% (Address%)

'PDQ Function
DECLARE FUNCTION PDQValI% (Number$)

'Constants
CONST False = 0, True = NOT False

'Executable code follows
Copyright$ = "Copyright (c) 1994  John De Palma"
REDIM SHARED Box$(1 TO 56)
Again:
CALL ColorIt(15, 1)
CLS
CursorOff
REDIM ComPort%(1 TO 4)
REDIM NoComPort%(1 TO 4)
REDIM SetComPort%(1 TO 4)

'get COM port addresses
DEF SEG = &H40

ComPort%(1) = PEEK(0) + PEEK(1) * 256
ComPort%(2) = PEEK(2) + PEEK(3) * 256
ComPort%(3) = PEEK(4) + PEEK(5) * 256
ComPort%(4) = PEEK(6) + PEEK(7) * 256

DEF SEG

Message$ = SPACE$(30)
CALL ColorIt(15, 4)
CALL TextBoxShadow(3, 0, Message$, 2, 1, 5)
Title$ = "BIOS Address of COM Port(s)"
CALL WidenMsg(30, Title$)
CALL ColorIt(12, 0)
CALL LocateIt(3, Title$)

FOR i% = 1 TO 4

        IF ComPort%(i%) <> 0 THEN
		CALL ColorIt(14, 4)
		text$ = "COM Port" + STR$(i%) + " Address is " + HEX$(ComPort%(i%))
		CALL LocateIt(4 + i%, text$)
	ELSE
		CALL ColorIt(11, 0)
		text$ = "COM Port" + STR$(i%) + " NOT Found  000"
		NoComPort(i%) = i%
		CALL LocateIt(4 + i%, text$)
	END IF
	CALL ColorIt(15, 1)
NEXT

	'this is a debug command to test all 4 com ports
	 'FOR z% = 1 TO 4
	 '    NoComPort(z%) = z%
	 'NEXT
	'STOP


	FOR j% = 1 TO 4
		IF NoComPort(j%) THEN
			Message$ = "Do you want to FILL the EMPTY COM" + LTRIM$(STR$(NoComPort(j%)))
			CALL ColorIt(11, 3)
			CALL TextBoxShadow(13, 0, Message$, 5, 1, 0)
			Title$ = " PRESS: 'Y' or {Enter} for Yes, or 'N' for NO "
			CALL WidenMsg(26, Title$)
			CALL ColorIt(15, 2)
			CALL LocateIt(12, Title$)
			Spaces$ = SPACE$(0)
			CALL TextBoxShadow(17, 0, Spaces$, 1, 1, 0)
		   
			Answer$ = "yY" + CHR$(13) + "nN"       'neat to use {Enter}
			YN% = YesNo%(Answer$)
			'STOP
			IF YN% > 0 AND YN% < 4 THEN
					LOCATE 18, 40
					PRINT "Y"
					SetComPort%(j%) = True
					Text2$ = "PRESS: A Key to continue or <Esc> to END"
					text$ = "COM Port Number" + STR$(NoComPort(j%)) + " being SET!"
					SetMessage$ = SPACE$(LEN(Text2$))
					CALL ColorIt(11, 3)
					CALL TextBoxShadow(21, 0, SetMessage$, 3, 0, 1)
					CALL LocateIt(22, text$)
					CALL ColorIt(14, 3)
					CALL LocateIt(23, Text2$)
					BEEP
					WaitKey
				ELSE
					LOCATE 18, 40
					PRINT "N"
					SetComPort%(j%) = False
				END IF
	   
			ELSE
				'STOP
				SetComPort%(j%) = False

		END IF
NEXT

                FOR k% = 1 TO 4
		   
			'IF NoComPort(k%) THEN
			IF SetComPort(k%) = True THEN
			   
				DEF SEG = &H40
			   
				SELECT CASE k%
					
					CASE 1
						'the next uses a FUNCTION from PDQ Library
						'the QuickBASIC code is commented out
						Value% = PDQValI%("&H" + "3F8")
						CALL PokeWord(0, Value%)
						'CALL PokeWord(0, VAL("&H" + "3F8"))
					CASE 2
						Value% = PDQValI%("&H" + "2F8")
						CALL PokeWord(2, Value%)
						'CALL PokeWord(2, VAL("&H" + "2F8"))
					CASE 3
						Value% = PDQValI%("&H" + "3E8")
						CALL PokeWord(4, Value%)
						'CALL PokeWord(4, VAL("&H" + "3E8"))
					CASE 4
						'STOP
						Value% = PDQValI%("&H" + "2E8")
						CALL PokeWord(6, Value%)
						'CALL PokeWord(6, VAL("&H" + "2E8"))
					CASE ELSE

				END SELECT
		   
				DEF SEG
		   
			END IF
		NEXT

	FOR x% = 1 TO 4

	IF SetComPort(x%) = True THEN
		CALL ColorIt(15, 1)
		CLS
		Message$ = "We have reset at least One COM Port"
		Message2$ = "Do you want to redisplay the COM Port Settings"
		Message3$ = Title$
		Spaces$ = SPACE$(LEN(Message3$))
		CALL ColorIt(15, 4)
		CALL TextBoxShadow(8, 0, Spaces$, 5, 1, 2)
		CALL ColorIt(14, 4)
		CALL LocateIt(9, Message$)
		CALL LocateIt(10, Message2$)
		CALL ColorIt(15, 4)
		CALL LocateIt(11, Message3$)
	   

			Answer$ = "yY" + CHR$(13) + "nN"       'neat to use {Enter}
			YN% = YesNo%(Answer$)
			IF YN% > 0 AND YN% < 4 THEN
				'STOP
				GOTO Again
			END IF
		'STOP
	 END IF
	 NEXT
		'STOP
		CALL ColorIt(15, 2)
		Message$ = " COM Program Ends "
		CALL TextBoxShadow(20, 10, Message$, 5, 1, 0)

		CALL ColorIt(13, 4)
		Message$ = "John De Palma on CompuServe 76076,571"
		CALL WidenMsg(44, Message$)
		CALL LocateIt(16, Message$)
		CALL TextBoxShadow(15, 0, Message$, 1, 1, 0)

CALL WaitKey
CALL ColorIt(7, 0)
CursorOn
END


FUNCTION Center% (text$)
	Center% = 41 - LEN(text$) \ 2
END FUNCTION

SUB ColorIt (Fgd, Bkg)
	COLOR Fgd, Bkg
END SUB

SUB CursorOff2
	LOCATE , , 0
END SUB

SUB CursorOn2
	LOCATE , , 1, 4, 7
END SUB

SUB LocateIt (Row%, text$)
	 LOCATE Row%, 41 - (LEN(text$)) \ 2
	 PRINT text$;
END SUB

SUB PokeWord (Address%, Value%)

	'the next two statements poke an integer
	POKE Address%, Value% AND 255
	POKE Address% + 1, Value% \ 256
	'test mode... this is dangerous stuff!!!
	'LOCATE 3, 4: PRINT Address%, Value% AND 255
	'LOCATE 5, 4: PRINT Address% + 1, Value% \ 256

END SUB

SUB TextBoxShadow (Row%, Col%, Message$, Outline%, Shadow%, Length%)
   
	'got to have a REDIM SHARED Box$(1 to 56) in main module
	'Other SUBs Needed for this are:
	'TwoColrs(Fgd%, Bkg%, Colr%)
	'LocateIt(Row%, Text$)
	'
	'Puts a message into a three line box -or-
	'draw a box without a message using Message$=SPACE$(x)
	'where "x" is the width of the box and Length%= number of lines > 3
	'Boxes are centered if Col% = 0; else left side of box = Col%.
	'Boxes display a true shadow if Shadow% <> 0
	'True = -1: False = 0

	STATIC BoxReadFlag
	Message$ = LEFT$(Message$, 60)
	BoxWidth% = LEN(Message$) + 4
	SELECT CASE Outline%
		CASE 0
			j = 8 * 6 + 1
		CASE 1
			j = 1
		CASE 2
			j = 8 + 1
		CASE 3
			j = 8 * 2 + 1
		CASE 4
			j = 8 * 3 + 1
		CASE 5
			j = 8 * 4 + 1
		CASE 6
			j = 8 * 5 + 1
		CASE ELSE
			j = 8 * 6 + 1
	END SELECT

	IF BoxReadFlag THEN GOTO Skip
	REDIM Box$(1 TO 56)
	BoxReadFlag = True

'single line box
	Box$(1) = ""
	Box$(2) = ""
	Box$(3) = ""
	Box$(4) = ""
	Box$(5) = ""
	Box$(6) = ""
	Box$(7) = ""
	Box$(8) = ""

'double top box
	Box$(9) = ""
	Box$(10) = ""
	Box$(11) = ""
	Box$(12) = ""
	Box$(13) = ""
	Box$(14) = ""
	Box$(15) = ""
	Box$(16) = ""

'double side box
	Box$(17) = ""
	Box$(18) = ""
	Box$(19) = ""
	Box$(20) = ""
	Box$(21) = ""
	Box$(22) = ""
	Box$(23) = ""
	Box$(24) = ""

'double box
	Box$(25) = ""
	Box$(26) = ""
	Box$(27) = ""
	Box$(28) = ""
	Box$(29) = ""
	Box$(30) = ""
	Box$(31) = ""
	Box$(32) = ""

'bold box
	Box$(33) = ""
	Box$(34) = ""
	Box$(35) = ""
	Box$(36) = ""
	Box$(37) = ""
	Box$(38) = ""
	Box$(39) = ""
	Box$(40) = ""

'bold and thick box
	Box$(41) = ""
	Box$(42) = ""
	Box$(43) = ""
	Box$(44) = ""
	Box$(45) = ""
	Box$(46) = ""
	Box$(47) = ""
	Box$(48) = ""

'no box
	Box$(49) = " "
	Box$(50) = " "
	Box$(51) = " "
	Box$(52) = " "
	Box$(53) = " "
	Box$(54) = " "
	Box$(55) = " "
	Box$(56) = " "

Skip:

	
   
	IF Col% = 0 THEN

			BoxText$ = Box$(j) + STRING$(BoxWidth%, Box$(j + 1)) + Box$(j + 2)
			CALL LocateIt(Row%, BoxText$)
			Row2% = CSRLIN: Col2% = POS(0)
			Colr% = SCREEN(Row2%, Col2% - 1, 1)
			GOSUB GetTwoColors
			'CALL TwoColrs(Fgd%, Bkg%, Colr%)
	
			FOR i = 1 TO Length% + 1
			BoxText$ = Box$(j + 3) + "  " + Message$ + "  " + Box$(j + 4)
			CALL LocateIt(Row% + i, BoxText$)

			IF Shadow% THEN
				COLOR 7, 0
					FOR k = 1 TO 2
						PRINT CHR$(SCREEN(CSRLIN, POS(0)));
					NEXT
				COLOR Fgd%, Bkg%
			END IF
			NEXT i

			BoxText$ = Box$(j + 5) + STRING$(BoxWidth%, Box$(j + 6)) + Box$(j + 7)
			CALL LocateIt(Row% + i, BoxText$)
	  
			IF Shadow% THEN
				COLOR 7, 0
				FOR k = 1 TO 2
					PRINT CHR$(SCREEN(CSRLIN, POS(0)));
				NEXT
			'COLOR Fgd%, Bkg%
	
			COLOR 7, 0
			LOCATE Row% + i + 1, Center(BoxText$) + 2
	  
				FOR k = 1 TO BoxWidth% + 2
					PRINT CHR$(SCREEN(CSRLIN, POS(0)));
				NEXT
				COLOR Fgd%, Bkg%
			END IF
	ELSE

			BoxText$ = Box$(j) + STRING$(BoxWidth%, Box$(j + 1)) + Box$(j + 2)
			LOCATE Row%, Col%
			PRINT BoxText$;
			Row2% = CSRLIN: Col2% = POS(0)
			Colr% = SCREEN(Row2%, Col2% - 1, 1)
			CALL TwoColrs(Fgd%, Bkg%, Colr%)

			FOR i = 1 TO Length% + 1
			BoxText$ = Box$(j + 3) + "  " + Message$ + "  " + Box$(j + 4)
			LOCATE Row% + i, Col%
			PRINT BoxText$;
	  
			IF Shadow% THEN
				COLOR 7, 0
				FOR k = 1 TO 2
					PRINT CHR$(SCREEN(CSRLIN, POS(0)));
				NEXT
				COLOR Fgd%, Bkg%
			END IF
	  
			NEXT i

			BoxText$ = Box$(j + 5) + STRING$(BoxWidth%, Box$(j + 6)) + Box$(j + 7)
			LOCATE Row% + i, Col%
			PRINT BoxText$;
	  
			IF Shadow% THEN
				COLOR 7, 0
				FOR k = 1 TO 2
					PRINT CHR$(SCREEN(CSRLIN, POS(0)));
				NEXT
			   
				LOCATE Row% + i + 1, Col% + 2
				FOR k = 1 TO BoxWidth% + 2
					PRINT CHR$(SCREEN(CSRLIN, POS(0)));
				NEXT
				COLOR Fgd%, Bkg%
			END IF

	END IF
	EXIT SUB
GetTwoColors:
	Fgd% = (Colr% AND 128) \ 8 + (Colr% AND 15)
	Bkg% = (Colr% AND 112) \ 16
RETURN

END SUB

SUB TwoColrs (Fgd%, Bkg%, Colr%)

	Fgd% = (Colr% AND 128) \ 8 + (Colr% AND 15)
	Bkg% = (Colr% AND 112) \ 16

END SUB

SUB WaitKey

	WHILE INKEY$ <> "": WEND
	DO
		Kee$ = INKEY$
	LOOP UNTIL LEN(Kee$)
	IF Kee$ = CHR$(27) THEN END

END SUB

SUB WidenMsg (MsgLength%, Message$)

	 Length% = LEN(Message$)

	 WHILE Length% < MsgLength%
		  Message$ = " " + Message$ + " "
		  Length% = LEN(Message$)
	 WEND

END SUB

FUNCTION YesNo% (Answer$) STATIC
	'STOP
 
	WHILE INKEY$ <> "": WEND
 
	DO
		YN$ = INKEY$
	LOOP UNTIL LEN(YN$)
	IF YN$ = CHR$(27) THEN END

	YesNo% = INSTR(Answer$, YN$)           'Answer$ is the search string

	'COMMANDS TO CALL THIS FUNCTION:
	'Answer$ = "yY" + CHR$(13) + "nN"       'neat to use {Enter}
	'IF YesNo2% > 0 AND YesNo2% < 4 THEN GOTO Again
		'IF YesNo2% <= 0 OR YesNo2% > 3 THEN PRINT "E"
		'can use a function key as:
		'F1$ = CHR$(0)+";"

END FUNCTION

'This file was last compiled with:
'BC d:\QB45\PDQ\2SET_COM.BAS  /o;
'LINK 2SET_COM+
'     d:\QB45\PDQ\_NOERROR d:\QB45\PDQ\_CPRINT d:\QB45\PDQ\_NOREAD+
'     /nod /noe /packcode /far
'
'     nul
'     d:\QB45\PDQ\PDQ
